function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { EditorView } from '@codemirror/view';
import useTheme from '@mui/material/styles/useTheme';
export const useEditorTheme = readOnly => {
  var _components$MuiTextFi, _components$MuiTextFi2, _components$MuiOutlin, _components$MuiOutlin2, _components$MuiOutlin3;

  const {
    palette,
    shape,
    components
  } = useTheme();
  const variant = (components === null || components === void 0 ? void 0 : (_components$MuiTextFi = components.MuiTextField) === null || _components$MuiTextFi === void 0 ? void 0 : (_components$MuiTextFi2 = _components$MuiTextFi.defaultProps) === null || _components$MuiTextFi2 === void 0 ? void 0 : _components$MuiTextFi2.variant) || 'standard';
  const styleBorderRadius = components === null || components === void 0 ? void 0 : (_components$MuiOutlin = components.MuiOutlinedInput) === null || _components$MuiOutlin === void 0 ? void 0 : (_components$MuiOutlin2 = _components$MuiOutlin.styleOverrides) === null || _components$MuiOutlin2 === void 0 ? void 0 : (_components$MuiOutlin3 = _components$MuiOutlin2.root) === null || _components$MuiOutlin3 === void 0 ? void 0 : _components$MuiOutlin3.borderRadius;
  const borderRadiusTmp = typeof styleBorderRadius !== 'undefined' ? styleBorderRadius : shape.borderRadius;
  const borderRadius = variant === 'standard' ? typeof borderRadiusTmp === 'number' ? borderRadiusTmp + 'px' : borderRadiusTmp : 0;
  return React.useMemo(() => EditorView.theme(_objectSpread(_objectSpread(_objectSpread({
    '&': {
      color: palette.text.primary,
      backgroundColor: palette.background.paper
    },
    '&.cm-editor': {
      outline: '1px solid ' + (variant === 'standard' ? palette.divider : 'transparent'),
      borderRadius: borderRadius
    }
  }, variant !== 'standard' || readOnly ? {} : {
    '&.cm-editor:hover': {
      outline: '1px solid ' + palette.text.primary
    }
  }), variant !== 'standard' ? {} : {
    '&.cm-editor.invalid': {
      outline: '1px solid ' + palette.error.main
    },
    '&.cm-editor.cm-focused': {
      outline: '2px solid ' + palette.primary.main
    },
    '&.cm-editor.cm-focused.invalid': {
      outline: '2px solid ' + palette.error.main
    }
  }), {}, {
    '& .cm-content': {
      caretColor: palette.text.primary
    },
    '&.cm-focused .cm-cursor': {
      borderLeftColor: palette.text.primary
    },
    '&.cm-editor.cm-focused .cm-activeLine': {
      backgroundColor: palette.divider
    },
    '&.cm-editor .cm-activeLine': {
      backgroundColor: 'transparent'
    },
    '&.cm-editor.cm-focused .cm-gutterElement.cm-activeLineGutter': {
      backgroundColor: palette.divider
    },
    '& .cm-gutterElement.cm-activeLineGutter': {
      backgroundColor: 'transparent'
    },
    '&.cm-focused .cm-selectionBackground, ::selection': {
      backgroundColor: palette.divider
    },
    '& .cm-gutters': {
      backgroundColor: palette.background.default,
      color: palette.text.secondary,
      border: 'none',
      borderTopLeftRadius: borderRadius,
      borderBottomLeftRadius: borderRadius
    },
    '& .cm-gutters .cm-lineNumbers .cm-gutterElement': {
      paddingLeft: '8px'
    }
  }), {
    dark: palette.mode === 'dark'
  }), [palette, readOnly, borderRadius, variant]);
};